diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/netanim/model/animation-interface.cc ns-3.31/src/netanim/model/animation-interface.cc
--- ns-3.30.1/src/netanim/model/animation-interface.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/netanim/model/animation-interface.cc	2020-06-27 17:38:30.000000000 -0700
@@ -1477,44 +1507,44 @@
     }
 }
 
-void 
+void
 AnimationInterface::AddToIpv4AddressNodeIdTable (std::string ipv4Address, uint32_t nodeId)
 {
   m_ipv4ToNodeIdMap[ipv4Address] = nodeId;
-  m_nodeIdIpv4Map.insert(NodeIdIpv4Pair(nodeId, ipv4Address));
+  m_nodeIdIpv4Map.insert (NodeIdIpv4Pair (nodeId, ipv4Address));
 }
 
-void 
+void
 AnimationInterface::AddToIpv4AddressNodeIdTable (std::vector<std::string> ipv4Addresses, uint32_t nodeId)
 {
   for (std::vector<std::string>::const_iterator i = ipv4Addresses.begin ();
-	  i != ipv4Addresses.end ();
-	  ++i)
+       i != ipv4Addresses.end ();
+       ++i)
     {
-	  AddToIpv4AddressNodeIdTable (*i, nodeId);
+      AddToIpv4AddressNodeIdTable (*i, nodeId);
     }
 }
 
 void
-AnimationInterface::AddToIpv6AddressNodeIdTable(std::string ipv6Address, uint32_t nodeId)
+AnimationInterface::AddToIpv6AddressNodeIdTable (std::string ipv6Address, uint32_t nodeId)
 {
-	m_ipv6ToNodeIdMap[ipv6Address] = nodeId;
-	m_nodeIdIpv6Map.insert(NodeIdIpv6Pair(nodeId, ipv6Address));
+  m_ipv6ToNodeIdMap[ipv6Address] = nodeId;
+  m_nodeIdIpv6Map.insert (NodeIdIpv6Pair (nodeId, ipv6Address));
 }
 
 void
-AnimationInterface::AddToIpv6AddressNodeIdTable(std::vector<std::string> ipv6Addresses, uint32_t nodeId)
+AnimationInterface::AddToIpv6AddressNodeIdTable (std::vector<std::string> ipv6Addresses, uint32_t nodeId)
 {
-	for (std::vector<std::string>::const_iterator i = ipv6Addresses.begin();
-		i != ipv6Addresses.end();
-		++i)
-	{
-		AddToIpv6AddressNodeIdTable(*i, nodeId);
-	}
+  for (std::vector<std::string>::const_iterator i = ipv6Addresses.begin ();
+       i != ipv6Addresses.end ();
+       ++i)
+    {
+      AddToIpv6AddressNodeIdTable (*i, nodeId);
+    }
 }
 
 // Callbacks
-void 
+void
 AnimationInterface::ConnectLteEnb (Ptr <Node> n, Ptr <LteEnbNetDevice> nd, uint32_t devIndex)
 {
 
@@ -1538,7 +1568,7 @@
 
 
 
-void 
+void
 AnimationInterface::ConnectLteUe (Ptr <Node> n, Ptr <LteUeNetDevice> nd, uint32_t devIndex)
 {
 
@@ -1555,12 +1585,12 @@
     }
   if (ulPhy)
     {
-       ulPhy->TraceConnect ("TxStart", oss.str (), MakeCallback (&AnimationInterface::LteSpectrumPhyTxStart, this));
-       ulPhy->TraceConnect ("RxStart", oss.str (), MakeCallback (&AnimationInterface::LteSpectrumPhyRxStart, this));
+      ulPhy->TraceConnect ("TxStart", oss.str (), MakeCallback (&AnimationInterface::LteSpectrumPhyTxStart, this));
+      ulPhy->TraceConnect ("RxStart", oss.str (), MakeCallback (&AnimationInterface::LteSpectrumPhyRxStart, this));
     }
 }
 
-void 
+void
 AnimationInterface::ConnectLte ()
 {
 
@@ -1573,7 +1603,9 @@
         {
           Ptr <NetDevice> nd = n->GetDevice (devIndex);
           if (!nd)
-            continue;
+            {
+              continue;
+            }
           Ptr<LteUeNetDevice> lteUeNetDevice = DynamicCast<LteUeNetDevice> (nd);
           if (lteUeNetDevice)
             {
@@ -1582,122 +1614,124 @@
             }
           Ptr<LteEnbNetDevice> lteEnbNetDevice = DynamicCast<LteEnbNetDevice> (nd);
           if (lteEnbNetDevice)
-            ConnectLteEnb (n, lteEnbNetDevice, devIndex);
+            {
+              ConnectLteEnb (n, lteEnbNetDevice, devIndex);
+            }
         }
 
     }
 }
 
-void 
+void
 AnimationInterface::ConnectCallbacks ()
 {
   // Connect the callbacks
-  Config::Connect ("/ChannelList/*/TxRxPointToPoint",
-                   MakeCallback (&AnimationInterface::DevTxTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/PhyTxBegin",
-                   MakeCallback (&AnimationInterface::WifiPhyTxBeginTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/PhyRxBegin",
-                   MakeCallback (&AnimationInterface::WifiPhyRxBeginTrace, this));
-  Config::ConnectWithoutContext ("/NodeList/*/$ns3::MobilityModel/CourseChange",
-                   MakeCallback (&AnimationInterface::MobilityCourseChangeTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WimaxNetDevice/Tx",
-                   MakeCallback (&AnimationInterface::WimaxTxTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WimaxNetDevice/Rx",
-                   MakeCallback (&AnimationInterface::WimaxRxTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::LteNetDevice/Tx",
-                   MakeCallback (&AnimationInterface::LteTxTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::LteNetDevice/Rx",
-                   MakeCallback (&AnimationInterface::LteRxTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/PhyTxBegin",
-                   MakeCallback (&AnimationInterface::CsmaPhyTxBeginTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/PhyTxEnd",
-                   MakeCallback (&AnimationInterface::CsmaPhyTxEndTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/PhyRxEnd",
-                   MakeCallback (&AnimationInterface::CsmaPhyRxEndTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/MacRx",
-                   MakeCallback (&AnimationInterface::CsmaMacRxTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::UanNetDevice/Phy/PhyTxBegin",
-                   MakeCallback (&AnimationInterface::UanPhyGenTxTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::UanNetDevice/Phy/PhyRxBegin",
-                   MakeCallback (&AnimationInterface::UanPhyGenRxTrace, this));
-  Config::Connect ("/NodeList/*/$ns3::BasicEnergySource/RemainingEnergy",
-                   MakeCallback (&AnimationInterface::RemainingEnergyTrace, this));
-
+  Config::ConnectFailSafe ("/ChannelList/*/TxRxPointToPoint",
+                           MakeCallback (&AnimationInterface::DevTxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/PhyTxPsduBegin",
+                           MakeCallback (&AnimationInterface::WifiPhyTxBeginTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/PhyRxBegin",
+                           MakeCallback (&AnimationInterface::WifiPhyRxBeginTrace, this));
+  Config::ConnectWithoutContextFailSafe ("/NodeList/*/$ns3::MobilityModel/CourseChange",
+                                         MakeCallback (&AnimationInterface::MobilityCourseChangeTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::WimaxNetDevice/Tx",
+                           MakeCallback (&AnimationInterface::WimaxTxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::WimaxNetDevice/Rx",
+                           MakeCallback (&AnimationInterface::WimaxRxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::LteNetDevice/Tx",
+                           MakeCallback (&AnimationInterface::LteTxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::LteNetDevice/Rx",
+                           MakeCallback (&AnimationInterface::LteRxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/PhyTxBegin",
+                           MakeCallback (&AnimationInterface::CsmaPhyTxBeginTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/PhyTxEnd",
+                           MakeCallback (&AnimationInterface::CsmaPhyTxEndTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/PhyRxEnd",
+                           MakeCallback (&AnimationInterface::CsmaPhyRxEndTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/MacRx",
+                           MakeCallback (&AnimationInterface::CsmaMacRxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::UanNetDevice/Phy/PhyTxBegin",
+                           MakeCallback (&AnimationInterface::UanPhyGenTxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::UanNetDevice/Phy/PhyRxBegin",
+                           MakeCallback (&AnimationInterface::UanPhyGenRxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/$ns3::BasicEnergySource/RemainingEnergy",
+                           MakeCallback (&AnimationInterface::RemainingEnergyTrace, this));
+  
   ConnectLte ();
-
-  Config::Connect ("/NodeList/*/$ns3::Ipv4L3Protocol/Tx",
-                   MakeCallback (&AnimationInterface::Ipv4TxTrace, this));
-  Config::Connect ("/NodeList/*/$ns3::Ipv4L3Protocol/Rx",
-                   MakeCallback (&AnimationInterface::Ipv4RxTrace, this));
-  Config::Connect ("/NodeList/*/$ns3::Ipv4L3Protocol/Drop",
-                   MakeCallback (&AnimationInterface::Ipv4DropTrace, this));
-
+  
+  Config::ConnectFailSafe ("/NodeList/*/$ns3::Ipv4L3Protocol/Tx",
+                           MakeCallback (&AnimationInterface::Ipv4TxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/$ns3::Ipv4L3Protocol/Rx",
+                           MakeCallback (&AnimationInterface::Ipv4RxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/$ns3::Ipv4L3Protocol/Drop",
+                           MakeCallback (&AnimationInterface::Ipv4DropTrace, this));
+  
   // Queue Enqueues
-
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::AlohaNoackNetDevice/Queue/Enqueue",
-                   MakeCallback (&AnimationInterface::EnqueueTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/TxQueue/Enqueue",
-                   MakeCallback (&AnimationInterface::EnqueueTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::PointToPointNetDevice/TxQueue/Enqueue",
-                   MakeCallback (&AnimationInterface::EnqueueTrace, this));
-
+  
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::AlohaNoackNetDevice/Queue/Enqueue",
+                           MakeCallback (&AnimationInterface::EnqueueTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/TxQueue/Enqueue",
+                           MakeCallback (&AnimationInterface::EnqueueTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::PointToPointNetDevice/TxQueue/Enqueue",
+                           MakeCallback (&AnimationInterface::EnqueueTrace, this));
+  
   // Queue Dequeues
-
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::AlohaNoackNetDevice/Queue/Dequeue",
-                   MakeCallback (&AnimationInterface::DequeueTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/TxQueue/Dequeue",
-                   MakeCallback (&AnimationInterface::DequeueTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::PointToPointNetDevice/TxQueue/Dequeue",
-                   MakeCallback (&AnimationInterface::DequeueTrace, this));
-
-  // Queue Drops 
-
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::AlohaNoackNetDevice/Queue/Drop",
-                   MakeCallback (&AnimationInterface::QueueDropTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/TxQueue/Drop",
-                   MakeCallback (&AnimationInterface::QueueDropTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::PointToPointNetDevice/TxQueue/Drop",
-                   MakeCallback (&AnimationInterface::QueueDropTrace, this));
-
-
+  
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::AlohaNoackNetDevice/Queue/Dequeue",
+                           MakeCallback (&AnimationInterface::DequeueTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/TxQueue/Dequeue",
+                           MakeCallback (&AnimationInterface::DequeueTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::PointToPointNetDevice/TxQueue/Dequeue",
+                           MakeCallback (&AnimationInterface::DequeueTrace, this));
+  
+  // Queue Drops
+  
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::AlohaNoackNetDevice/Queue/Drop",
+                           MakeCallback (&AnimationInterface::QueueDropTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/TxQueue/Drop",
+                           MakeCallback (&AnimationInterface::QueueDropTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::PointToPointNetDevice/TxQueue/Drop",
+                           MakeCallback (&AnimationInterface::QueueDropTrace, this));
+  
+  
   // Wifi Mac
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/MacTx",
-                   MakeCallback (&AnimationInterface::WifiMacTxTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/MacTxDrop",
-                   MakeCallback (&AnimationInterface::WifiMacTxDropTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/MacRx",
-                   MakeCallback (&AnimationInterface::WifiMacRxTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/MacRxDrop",
-                   MakeCallback (&AnimationInterface::WifiMacRxDropTrace, this));
-
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/MacTx",
+                           MakeCallback (&AnimationInterface::WifiMacTxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/MacTxDrop",
+                           MakeCallback (&AnimationInterface::WifiMacTxDropTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/MacRx",
+                           MakeCallback (&AnimationInterface::WifiMacRxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/MacRxDrop",
+                           MakeCallback (&AnimationInterface::WifiMacRxDropTrace, this));
+  
   // Wifi Phy
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/PhyTxDrop",
-                   MakeCallback (&AnimationInterface::WifiPhyTxDropTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/PhyRxDrop",
-                   MakeCallback (&AnimationInterface::WifiPhyRxDropTrace, this));
-
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/PhyTxDrop",
+                           MakeCallback (&AnimationInterface::WifiPhyTxDropTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/PhyRxDrop",
+                           MakeCallback (&AnimationInterface::WifiPhyRxDropTrace, this));
+  
   // LrWpan
-  Config::Connect ("NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Phy/PhyTxBegin",
-                   MakeCallback (&AnimationInterface::LrWpanPhyTxBeginTrace, this));
-  Config::Connect ("NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Phy/PhyRxBegin",
-                   MakeCallback (&AnimationInterface::LrWpanPhyRxBeginTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Mac/MacTx",
-                   MakeCallback (&AnimationInterface::LrWpanMacTxTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Mac/MacTxDrop",
-                   MakeCallback (&AnimationInterface::LrWpanMacTxDropTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Mac/MacRx",
-                   MakeCallback (&AnimationInterface::LrWpanMacRxTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Mac/MacRxDrop",
-                   MakeCallback (&AnimationInterface::LrWpanMacRxDropTrace, this));
-
+  Config::ConnectFailSafe ("NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Phy/PhyTxBegin",
+                           MakeCallback (&AnimationInterface::LrWpanPhyTxBeginTrace, this));
+  Config::ConnectFailSafe ("NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Phy/PhyRxBegin",
+                           MakeCallback (&AnimationInterface::LrWpanPhyRxBeginTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Mac/MacTx",
+                           MakeCallback (&AnimationInterface::LrWpanMacTxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Mac/MacTxDrop",
+                           MakeCallback (&AnimationInterface::LrWpanMacTxDropTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Mac/MacRx",
+                           MakeCallback (&AnimationInterface::LrWpanMacRxTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Mac/MacRxDrop",
+                           MakeCallback (&AnimationInterface::LrWpanMacRxDropTrace, this));
+  
   // Wave
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WaveNetDevice/PhyEntities/*/$ns3::WifiPhy/PhyTxBegin",
-                   MakeCallback (&AnimationInterface::WavePhyTxBeginTrace, this));
-  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WaveNetDevice/PhyEntities/*/$ns3::WifiPhy/PhyRxBegin",
-                   MakeCallback (&AnimationInterface::WavePhyRxBeginTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::WaveNetDevice/PhyEntities/*/$ns3::WifiPhy/PhyTxBegin",
+                           MakeCallback (&AnimationInterface::WavePhyTxBeginTrace, this));
+  Config::ConnectFailSafe ("/NodeList/*/DeviceList/*/$ns3::WaveNetDevice/PhyEntities/*/$ns3::WifiPhy/PhyRxBegin",
+                           MakeCallback (&AnimationInterface::WavePhyRxBeginTrace, this));
 }
 
-Vector 
+Vector
 AnimationInterface::UpdatePosition (Ptr <Node> n)
 {
   Ptr<MobilityModel> loc = n->GetObject<MobilityModel> ();
@@ -1706,20 +1740,20 @@
       m_nodeLocation[n->GetId ()] = loc->GetPosition ();
     }
   else
-   {
-     NS_LOG_UNCOND ( "AnimationInterface WARNING:Node:" << n->GetId () << " Does not have a mobility model. Use SetConstantPosition if it is stationary");
-     Ptr<UniformRandomVariable> x = CreateObject<UniformRandomVariable> ();
-     x->SetAttribute ("Min", DoubleValue (0));
-     x->SetAttribute ("Max", DoubleValue (100));
-     Ptr<UniformRandomVariable> y = CreateObject<UniformRandomVariable> ();
-     y->SetAttribute ("Min", DoubleValue (0));
-     y->SetAttribute ("Max", DoubleValue (100));
-     m_nodeLocation[n->GetId ()] = Vector (int (x->GetValue ()), int (y->GetValue ()), 0);
-   }
+    {
+      NS_LOG_UNCOND ( "AnimationInterface WARNING:Node:" << n->GetId () << " Does not have a mobility model. Use SetConstantPosition if it is stationary");
+      Ptr<UniformRandomVariable> x = CreateObject<UniformRandomVariable> ();
+      x->SetAttribute ("Min", DoubleValue (0));
+      x->SetAttribute ("Max", DoubleValue (100));
+      Ptr<UniformRandomVariable> y = CreateObject<UniformRandomVariable> ();
+      y->SetAttribute ("Min", DoubleValue (0));
+      y->SetAttribute ("Max", DoubleValue (100));
+      m_nodeLocation[n->GetId ()] = Vector (int (x->GetValue ()), int (y->GetValue ()), 0);
+    }
   return m_nodeLocation[n->GetId ()];
 }
 
-Vector 
+Vector
 AnimationInterface::UpdatePosition (Ptr <Node> n, Vector v)
 {
   m_nodeLocation[n->GetId ()] = v;
@@ -1734,18 +1768,18 @@
   return UpdatePosition (n);
 }
 
-Vector 
+Vector
 AnimationInterface::GetPosition (Ptr <Node> n)
 {
   if (m_nodeLocation.find (n->GetId ()) == m_nodeLocation.end ())
     {
-      NS_FATAL_ERROR ("Node:" <<n->GetId () << " not found in Location table");
-    }  
+      NS_FATAL_ERROR ("Node:" << n->GetId () << " not found in Location table");
+    }
   return m_nodeLocation[n->GetId ()];
 }
 
 
-std::string 
+std::string
 AnimationInterface::GetMacAddress (Ptr <NetDevice> nd)
 {
   Address nodeAddr = nd->GetAddress ();
@@ -1754,7 +1788,7 @@
   return oss.str ().substr (6); // Skip the first 6 chars to get the Mac
 }
 
-std::string 
+std::string
 AnimationInterface::GetIpv4Address (Ptr <NetDevice> nd)
 {
   Ptr<Ipv4> ipv4 = NodeList::GetNode (nd->GetNode ()->GetId ())->GetObject <Ipv4> ();
@@ -1776,37 +1810,39 @@
 }
 
 std::string
-AnimationInterface::GetIpv6Address(Ptr <NetDevice> nd)
+AnimationInterface::GetIpv6Address (Ptr <NetDevice> nd)
 {
-  Ptr<Ipv6> ipv6 = NodeList::GetNode(nd->GetNode()->GetId())->GetObject <Ipv6>();
+  Ptr<Ipv6> ipv6 = NodeList::GetNode (nd->GetNode ()->GetId ())->GetObject <Ipv6> ();
   if (!ipv6)
     {
-      NS_LOG_WARN("Node: " << nd->GetNode()->GetId() << " No ipv4 object found");
+      NS_LOG_WARN ("Node: " << nd->GetNode ()->GetId () << " No ipv4 object found");
       return "::";
     }
-  int32_t ifIndex = ipv6->GetInterfaceForDevice(nd);
+  int32_t ifIndex = ipv6->GetInterfaceForDevice (nd);
   if (ifIndex == -1)
     {
-      NS_LOG_WARN("Node :" << nd->GetNode()->GetId() << " Could not find index of NetDevice");
+      NS_LOG_WARN ("Node :" << nd->GetNode ()->GetId () << " Could not find index of NetDevice");
       return "::";
     }
   bool nonLinkLocalFound = false;
-  uint32_t nAddresses = ipv6->GetNAddresses(ifIndex);
+  uint32_t nAddresses = ipv6->GetNAddresses (ifIndex);
   Ipv6InterfaceAddress addr;
   for (uint32_t addressIndex = 0; addressIndex < nAddresses; ++addressIndex)
     {
-      addr = ipv6->GetAddress(ifIndex, addressIndex);
-      if (!addr.GetAddress().IsLinkLocal())
+      addr = ipv6->GetAddress (ifIndex, addressIndex);
+      if (!addr.GetAddress ().IsLinkLocal ())
         {
           nonLinkLocalFound = true;
-	  break;
+          break;
         }
     }
   if (!nonLinkLocalFound)
-    addr = ipv6->GetAddress(ifIndex, 0);
+    {
+      addr = ipv6->GetAddress (ifIndex, 0);
+    }
   std::ostringstream oss;
-  oss << addr.GetAddress();
-  return oss.str();
+  oss << addr.GetAddress ();
+  return oss.str ();
 }
 
 
@@ -1832,25 +1868,25 @@
       Ipv4InterfaceAddress addr = ipv4->GetAddress (ifIndex, index);
       std::ostringstream oss;
       oss << addr.GetLocal ();
-      ipv4Addresses.push_back(oss.str ());
+      ipv4Addresses.push_back (oss.str ());
     }
   return ipv4Addresses;
 }
 
 std::vector<std::string>
-AnimationInterface::GetIpv6Addresses(Ptr <NetDevice> nd)
+AnimationInterface::GetIpv6Addresses (Ptr <NetDevice> nd)
 {
   std::vector<std::string> ipv6Addresses;
   Ptr<Ipv6> ipv6 = NodeList::GetNode (nd->GetNode ()->GetId ())->GetObject <Ipv6> ();
   if (!ipv6)
     {
-      NS_LOG_WARN("Node: " << nd->GetNode ()->GetId () << " No ipv6 object found");
+      NS_LOG_WARN ("Node: " << nd->GetNode ()->GetId () << " No ipv6 object found");
       return ipv6Addresses;
     }
   int32_t ifIndex = ipv6->GetInterfaceForDevice (nd);
   if (ifIndex == -1)
     {
-      NS_LOG_WARN("Node :" << nd->GetNode ()->GetId () << " Could not find index of NetDevice");
+      NS_LOG_WARN ("Node :" << nd->GetNode ()->GetId () << " Could not find index of NetDevice");
       return ipv6Addresses;
     }
   for (uint32_t index = 0; index < ipv6->GetNAddresses (ifIndex); ++index)
@@ -1868,23 +1904,23 @@
 AnimationInterface::WriteIpv4Addresses ()
 {
   for (NodeIdIpv4Map::const_iterator i = m_nodeIdIpv4Map.begin ();
-       i != m_nodeIdIpv4Map.end();
+       i != m_nodeIdIpv4Map.end ();
        ++i)
     {
       std::vector <std::string> ipv4Addresses;
       std::pair<NodeIdIpv4Map::const_iterator, NodeIdIpv4Map::const_iterator> iterPair = m_nodeIdIpv4Map.equal_range (i->first);
       for (NodeIdIpv4Map::const_iterator it = iterPair.first;
-          it != iterPair.second; 
-          ++it)
+           it != iterPair.second;
+           ++it)
         {
           ipv4Addresses.push_back (it->second);
-	}
+        }
       WriteXmlIpv4Addresses (i->first, ipv4Addresses);
     }
 }
 
 void
-AnimationInterface::WriteIpv6Addresses()
+AnimationInterface::WriteIpv6Addresses ()
 {
   for (NodeIdIpv6Map::const_iterator i = m_nodeIdIpv6Map.begin ();
        i != m_nodeIdIpv6Map.end ();
@@ -1893,16 +1929,16 @@
       std::vector <std::string> ipv6Addresses;
       std::pair<NodeIdIpv6Map::const_iterator, NodeIdIpv6Map::const_iterator> iterPair = m_nodeIdIpv6Map.equal_range (i->first);
       for (NodeIdIpv6Map::const_iterator it = iterPair.first;
-           it != iterPair.second; 
+           it != iterPair.second;
            ++it)
         {
           ipv6Addresses.push_back (it->second);
-	}
-        WriteXmlIpv6Addresses (i->first, ipv6Addresses);
+        }
+      WriteXmlIpv6Addresses (i->first, ipv6Addresses);
     }
 }
 
-void 
+void
 AnimationInterface::WriteLinkProperties ()
 {
   for (NodeList::Iterator i = NodeList::Begin (); i != NodeList::End (); ++i)
@@ -1914,46 +1950,46 @@
       for (uint32_t i = 0; i < nDev; ++i)
         {
           Ptr<NetDevice> dev = n->GetDevice (i);
- 	  NS_ASSERT (dev);
-	  Ptr<Channel>   ch = dev->GetChannel ();
+          NS_ASSERT (dev);
+          Ptr<Channel>   ch = dev->GetChannel ();
           std::string channelType = "Unknown channel";
-	  if (ch)
+          if (ch)
             {
-	      channelType = ch->GetInstanceTypeId ().GetName ();
-	    }
-	  NS_LOG_DEBUG("Got ChannelType" << channelType);
+              channelType = ch->GetInstanceTypeId ().GetName ();
+            }
+          NS_LOG_DEBUG ("Got ChannelType" << channelType);
 
-          if (!ch || (channelType != std::string("ns3::PointToPointChannel")))
+          if (!ch || (channelType != std::string ("ns3::PointToPointChannel")))
             {
-	      NS_LOG_DEBUG ("No channel can't be a p2p device");
-	      /*
+              NS_LOG_DEBUG ("No channel can't be a p2p device");
+              /*
               // Try to see if it is an LTE NetDevice, which does not return a channel
-              if ((dev->GetInstanceTypeId ().GetName () == "ns3::LteUeNetDevice") || 
+              if ((dev->GetInstanceTypeId ().GetName () == "ns3::LteUeNetDevice") ||
                   (dev->GetInstanceTypeId ().GetName () == "ns3::LteEnbNetDevice")||
                   (dev->GetInstanceTypeId ().GetName () == "ns3::VirtualNetDevice"))
                 {
                   WriteNonP2pLinkProperties (n->GetId (), GetIpv4Address (dev) + "~" + GetMacAddress (dev), channelType);
                   AddToIpv4AddressNodeIdTable (GetIpv4Address (dev), n->GetId ());
                 }
-	       */
+               */
               std::vector<std::string> ipv4Addresses = GetIpv4Addresses (dev);
-	      AddToIpv4AddressNodeIdTable(ipv4Addresses, n->GetId ());
-	      std::vector<std::string> ipv6Addresses = GetIpv6Addresses (dev);
-              AddToIpv6AddressNodeIdTable(ipv6Addresses, n->GetId ());
-	      if (!ipv4Addresses.empty ())
+              AddToIpv4AddressNodeIdTable (ipv4Addresses, n->GetId ());
+              std::vector<std::string> ipv6Addresses = GetIpv6Addresses (dev);
+              AddToIpv6AddressNodeIdTable (ipv6Addresses, n->GetId ());
+              if (!ipv4Addresses.empty ())
+                {
+                  NS_LOG_INFO ("Writing Ipv4 link");
+                  WriteNonP2pLinkProperties (n->GetId (), GetIpv4Address (dev) + "~" + GetMacAddress (dev), channelType);
+                }
+              else if (!ipv6Addresses.empty ())
                 {
-                   NS_LOG_INFO ("Writing Ipv4 link");
-	           WriteNonP2pLinkProperties(n->GetId (), GetIpv4Address (dev) + "~" + GetMacAddress (dev), channelType);
-		}
-	      else if (!ipv6Addresses.empty ())
-	        {
                   NS_LOG_INFO ("Writing Ipv6 link");
-                  WriteNonP2pLinkProperties(n->GetId (), GetIpv6Address (dev) + "~" + GetMacAddress (dev), channelType);
-		}
+                  WriteNonP2pLinkProperties (n->GetId (), GetIpv6Address (dev) + "~" + GetMacAddress (dev), channelType);
+                }
               continue;
             }
 
-         else if (channelType == std::string ("ns3::PointToPointChannel"))
+          else if (channelType == std::string ("ns3::PointToPointChannel"))
             { // Since these are duplex links, we only need to dump
               // if srcid < dstid
               std::size_t nChDev = ch->GetNDevices ();
@@ -1962,30 +1998,30 @@
                   Ptr<NetDevice> chDev = ch->GetDevice (j);
                   uint32_t n2Id = chDev->GetNode ()->GetId ();
                   if (n1Id < n2Id)
-                    { 
+                    {
 
                       std::vector<std::string> ipv4Addresses = GetIpv4Addresses (dev);
                       AddToIpv4AddressNodeIdTable (ipv4Addresses, n1Id);
                       ipv4Addresses = GetIpv4Addresses (chDev);
-	              AddToIpv4AddressNodeIdTable (ipv4Addresses, n2Id);
-		      std::vector<std::string> ipv6Addresses = GetIpv6Addresses (dev);
-		      AddToIpv6AddressNodeIdTable(ipv6Addresses, n1Id);
-	              ipv6Addresses = GetIpv6Addresses (chDev);
-                      AddToIpv6AddressNodeIdTable(ipv6Addresses, n2Id);
+                      AddToIpv4AddressNodeIdTable (ipv4Addresses, n2Id);
+                      std::vector<std::string> ipv6Addresses = GetIpv6Addresses (dev);
+                      AddToIpv6AddressNodeIdTable (ipv6Addresses, n1Id);
+                      ipv6Addresses = GetIpv6Addresses (chDev);
+                      AddToIpv6AddressNodeIdTable (ipv6Addresses, n2Id);
 
                       P2pLinkNodeIdPair p2pPair;
                       p2pPair.fromNode = n1Id;
                       p2pPair.toNode = n2Id;
-		      if (!ipv4Addresses.empty ())
-		        {
+                      if (!ipv4Addresses.empty ())
+                        {
                           LinkProperties lp = { GetIpv4Address (dev) + "~" + GetMacAddress (dev), GetIpv4Address (chDev) + "~" + GetMacAddress (chDev), "" };
-			  m_linkProperties[p2pPair] = lp;
-		        }
-		      else if (!ipv6Addresses.empty ())
-		        {
-		          LinkProperties lp = { GetIpv6Address (dev) + "~" + GetMacAddress (dev), GetIpv6Address (chDev) + "~" + GetMacAddress (chDev), "" };
-			  m_linkProperties[p2pPair] = lp;
-		        }
+                          m_linkProperties[p2pPair] = lp;
+                        }
+                      else if (!ipv6Addresses.empty ())
+                        {
+                          LinkProperties lp = { GetIpv6Address (dev) + "~" + GetMacAddress (dev), GetIpv6Address (chDev) + "~" + GetMacAddress (chDev), "" };
+                          m_linkProperties[p2pPair] = lp;
+                        }
                       WriteXmlLink (n1Id, 0, n2Id);
                     }
                 }
@@ -2007,7 +2043,7 @@
     }
 }
 
-void 
+void
 AnimationInterface::WriteNodeColors ()
 {
   for (NodeList::Iterator i = NodeList::Begin (); i != NodeList::End (); ++i)
@@ -2015,14 +2051,14 @@
       Ptr<Node> n = *i;
       Rgb rgb = {255, 0, 0};
       if (m_nodeColors.find (n->GetId ()) == m_nodeColors.end ())
-      {
-        m_nodeColors[n->GetId ()] = rgb;
-      }
+        {
+          m_nodeColors[n->GetId ()] = rgb;
+        }
       UpdateNodeColor (n, rgb.r, rgb.g, rgb.b);
     }
 }
 
-void 
+void
 AnimationInterface::WriteNodeSizes ()
 {
   for (NodeList::Iterator i = NodeList::Begin (); i != NodeList::End (); ++i)
@@ -2035,7 +2071,7 @@
     }
 }
 
-void 
+void
 AnimationInterface::WriteNodeEnergies ()
 {
   m_remainingEnergyCounterId = AddNodeCounter ("RemainingEnergy", AnimationInterface::DOUBLE_COUNTER);
@@ -2049,17 +2085,21 @@
     }
 }
 
-bool 
+bool
 AnimationInterface::IsInTimeWindow ()
 {
-  if ((Simulator::Now () >= m_startTime) && 
-      (Simulator::Now () <= m_stopTime))
-    return true;
+  if ((Simulator::Now () >= m_startTime)
+      && (Simulator::Now () <= m_stopTime))
+    {
+      return true;
+    }
   else
-    return false;
+    {
+      return false;
+    }
 }
 
-void 
+void
 AnimationInterface::SetOutputFile (const std::string& fn, bool routing)
 {
   if (!routing && m_f)
